﻿function test_create_project() {
    asyncTest("测试创建一个项目",
           function () {
               var win = window.open('/Project/Create', 'SUT');

               setTimeout(function () {
                   var expected = {
                       Title: '从JS单元测试中创建的项目',
                       Owner: 'yimin_shi@hotmail.com',
                       StartDate: new Date(2010, 12, 23),
                       DueDate: new Date(2011, 12, 23),
                       ScmType: 'Svn',
                       ScmUrl: 'https://localhost:88/'
                   };

                   var form = $('FORM', win.document)[0];
                   fill_form(expected, form);
                   form.submit();
               }, 3000);

               setTimeout(function () {
                   equal(win.location.pathname, '/Project/My', '创建项目成功以后应该返回到我的项目列表页面！');
                   start();
                   win.close();
               }, 10000);
           });
};

function test_create_milestone() {
    asyncTest("测试创建一个里程碑", function () {
        var win = window.open('/Milestone/Create', 'SUT');

        setTimeout(function () {
            var expected = {
                Title: '从JS单元测试中创建的里程碑',
                StartDate: new Date(2010, 12, 23),
                DueDate: new Date(2011, 12, 23)
            };
            
            var form = $('FORM', win.document)[0];
            fill_form(expected, form);
            form.submit();
        }, 3000);

        setTimeout(function () {
            equal(win.location.pathname, '/Milestone', '创建项目成功以后应该返回到我的项目列表页面！');
            start();
            win.close();
        }, 10000);
    });
};

function test_create_project_without_scmtype() {
    asyncTest("测试创建一个项目，没有指定配置管理服务器地址", function () {
        var win = window.open('/Project/Create', 'SUT');

        setTimeout(function () {
            var expected = {
                Title: '从JS单元测试中创建的项目',
                Owner: 'yimin_shi@hotmail.com',
                StartDate: new Date(2010, 12, 23),
                DueDate: new Date(2011, 12, 23)
            };
            
            var form = $('FORM', win.document)[0];
            fill_form(expected, form);
            form.submit();
        }, 3000);

        setTimeout(function () {
            equal(win.location.pathname, '/Project/My', '创建项目成功以后应该返回到我的项目列表页面！');
            start();
            win.close();
        }, 10000);
    });
};

function test_create_project_without_scmurl() {
    asyncTest("测试创建一个项目，指定配置管理服务器，但没有指定地址，应该拒绝创建", function () {
        var win = window.open('/Project/Create', 'SUT');

        setTimeout(function () {
            var expected = {
                Title: '从JS单元测试中创建的项目',
                Owner: 'yimin_shi@hotmail.com',
                ScmType: 'Svn',
                StartDate: new Date(2010, 12, 23),
                DueDate: new Date(2011, 12, 23)
            };
            
            var form = $('FORM', win.document)[0];
            fill_form(expected, form);
            form.submit();
        }, 3000);

        setTimeout(function () {
            equal(win.location.pathname, '/Error', '指定配置管理系统类型，但没有指定配置管理系统地址，应该拒绝创建项目！');
            start();
            win.close();
        }, 10000);
    });
};

function test_create_project_with_milestone() {
    asyncTest("测试创建一个项目，并指定属于其的里程碑！", function () {
        var win = window.open('/Project/Create', 'SUT');

        setTimeout(function () {
            var expected = {
                Title: 'test_create_project_with_milestone_project',
                Owner: 'yimin_shi@hotmail.com',
                StartDate: new Date(2010, 12, 23),
                DueDate: new Date(2011, 12, 23)
            };

            var form = $('FORM', win.document)[0];
            fill_form(expected, form);

            var milestone = {
                Title: 'test_create_project_with_milestone_milestone',
                StartDate: new Date(2010, 12, 23),
                DueDate: new Date(2011, 1, 23)
            };

            $('#createRelatedObject', form).click();

            setTimeout(function () {
                var editor = $('#child_editor', win.document);
                var subform = $('FORM', editor)[0];

                fill_form(milestone, subform);
                click_ok_on_jqueryui_dialog(win.document);
            }, 3000);

            setTimeout(function () {
                var editor = $('#child_editor', win.document);
                equal(false, $(editor).dialog('isOpen'), "点击创建里程碑对话框上的确定按钮，会关闭创建里程碑对话框。");
                form.submit();
            }, 6000);
        }, 3000);

        setTimeout(function () {
            equal(win.location.pathname, '/Project/My', '创建项目成功以后应该返回到我的项目列表页面！');
            start();
            win.close();
        }, 15000);
    });
};

function run_milestone_tests() {
    test_create_project();
    test_create_milestone();
    test_create_project_without_scmtype();
    test_create_project_without_scmurl();
    test_create_project_with_milestone();
};