﻿function click_create_requirement_on_my_projects_page(win) {
    pid = $('ul.project-list > li:first', win.document).attr('title');
    var links = $('ul.project-list > li:first a:last', win.document);

    click_link(links[0], win);
};

function test_create_requirement_basic_scenario() {
    asyncTest("测试创建一个需求的基本场景",
           function () {
               var win = window.open('/Project/My', 'SUT');
               var pid;

               // 选择第一个项目里的"创建需求"链接
               setTimeout(function () {
                   click_create_requirement_on_my_projects_page(win);
               }, 3000);

               // 填写需求的详细信息
               setTimeout(function () {
                   var expected = {
                       Title: '从JS单元测试中创建的需求',
                       AssignedTo: 'yimin_shi@hotmail.com',
                       BusinessValue: 12345,
                       Tag: '测试,需求'
                   };
                   var form = $('FORM', win.document)[0];
                   fill_form(expected, form);
                   form.submit();
               }, 6000);

               setTimeout(function () {
                   equal(win.location.pathname, '/Requirement', '创建项目成功以后应该返回到我的项目列表页面！');
                   start();
                   win.close();
               }, 10000);
           });
       };

function test_create_requirement_withchildren_scenario() {
    asyncTest("测试创建一个包含子需求和子任务的场景", function () {
        var win = window.open('/Project/My', 'SUT');
        var pid;

        // 选择第一个项目里的"创建需求"链接
        setTimeout(function () {
            click_create_requirement_on_my_projects_page();
        }, 3000);

        // 填写需求的详细信息
        setTimeout(function () {
            var expected = {
                Title: '从JS单元测试中创建的需求',
                AssignedTo: 'yimin_shi@hotmail.com',
                BusinessValue: 12345,
                Tag: '测试,需求'
            };
            var form = $('FORM', win.document)[0];
            fill_form(expected, form);

            $('#addChildren', form).click();

            setTimeout(function () {
                var dialog = $('#action_dialog', win.document);
                $('#createTask', dialog).click();
            }, 3000);

            setTimeout(function () {
                var childTask = {
                    Title: 'test_create_requirement_withchildren_scenario_sub_task',
                    AssignedTo: 'yimin_shi@hotmail.com',
                    StartDate: new Date(2010, 12, 23),
                    DueDate: new Date(2011, 1, 23)
                };
                var editor = $('#child_editor', win.document);
                var subform = $('FORM', editor)[0];

                fill_form(childTask, subform);
                click_ok_on_jqueryui_dialog(win.document);
            }, 6000);

            setTimeout(function () {
                var editor = $('#child_editor', win.document);
                equal(false, $(editor).dialog('isOpen'), "点击创建里程碑对话框上的确定按钮，会关闭创建里程碑对话框。");
                form.submit();
            }, 9000);
        }, 6000);

        setTimeout(function () {
            equal(win.location.pathname, '/Requirement', '创建项目成功以后应该返回到我的项目列表页面！');
            start();
            win.close();
        }, 20000);
    });  
};

function test_create_task_basic_scenario() {

};

function run_task_tests() {
    // test_create_requirement_basic_scenario();
    test_create_requirement_withchildren_scenario();
    // test_create_task_basic_scenario();
};